searchData={"items":[{"type":"behaviour","title":"DataMapper","doc":"Define behaviours for a data-mapping module.","ref":"DataMapper.html"},{"type":"callback","title":"DataMapper.map/1","doc":"","ref":"DataMapper.html#c:map/1"},{"type":"callback","title":"DataMapper.map/2","doc":"","ref":"DataMapper.html#c:map/2"},{"type":"callback","title":"DataMapper.map_field/1","doc":"","ref":"DataMapper.html#c:map_field/1"},{"type":"callback","title":"DataMapper.map_list/1","doc":"","ref":"DataMapper.html#c:map_list/1"},{"type":"callback","title":"DataMapper.post_map_list_transform/1","doc":"","ref":"DataMapper.html#c:post_map_list_transform/1"},{"type":"callback","title":"DataMapper.post_map_transform/1","doc":"","ref":"DataMapper.html#c:post_map_transform/1"},{"type":"callback","title":"DataMapper.pre_map_list_transform/1","doc":"","ref":"DataMapper.html#c:pre_map_list_transform/1"},{"type":"callback","title":"DataMapper.pre_map_transform/1","doc":"","ref":"DataMapper.html#c:pre_map_transform/1"},{"type":"function","title":"DataMapper.to_map/1","doc":"","ref":"DataMapper.html#to_map/1"},{"type":"extras","title":"DataMapper","doc":"# DataMapper\n\n![Test](https://github.com/ryanwinchester/data_mapper/workflows/Test/badge.svg)\n\nA macro module and behaviour with default mapping implementations.\n\nThe docs can be found at [https://hexdocs.pm/data_mapper](https://hexdocs.pm/data_mapper).","ref":"readme.html"},{"type":"extras","title":"Installation - DataMapper","doc":"The package can be installed by adding `data_mapper` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:data_mapper, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - DataMapper","doc":"```elixir\ndefmodule FooMapper do\n  @moduledoc \"\"\"\n  Map the Foo external data to our own data structures.\n  \"\"\"\n  use DataMapper,\n    mappings: %{\n      \"someFoo\" => :foo,\n      \"someBar\" => :bar,\n      \"extraThing\" => :extra_thing\n    }\n\n  @impl DataMapper\n\n  def map_field({_, nil} = field), do: field\n\n  def map_field({:bar, field}) do\n    {:bar, field * 1000}\n  end\n\n  def map_field(field), do: field\nend\n```","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}